<?php

#############################################################################
#
# $Id: files.inc,v 1.3 2000/03/24 02:51:04 del Exp $
#
# Read in all definitions.
#
#############################################################################

function read_interfaces() {
  global $CONF;
  $interfacesr = file("$CONF/interfaces");
  return $interfacesr;
}

function read_protocols() {
  $protocolr = file("/etc/protocols");
  while ( list( $key, $val ) = each($protocolr) ) {
    #
    # Skip blank lines and comments
    #
    if ( strlen($val) < 5 ) continue;
    if ( substr($val, 0, 1) == "#" ) continue;
    $exploded = preg_split ("/[\s\/]+/", $val);
    $protocols[$exploded[0]] = intval($exploded[1]);
    $port = intval($exploded[1]);
  }
  asort($protocols);
  return $protocols;
}

function read_services() {
  $servicer = file("/etc/services");
  # Stuff at the top ...
  $services["HIPORTS/udp"] = "1024:65535";
  $services["HIPORTS/tcp"] = "1024:65535";
  while ( list($key,$val ) = each($servicer) ) {
    #
    # Skip blank lines and comments
    #
    if ( strlen($val) < 5 ) continue;
    if ( substr($val, 0, 1) == "#" ) continue;
    $exploded = preg_split ("/[\s\/]+/", $val);
    $service = $exploded[0];
    $port = intval($exploded[1]);
    $proto = $exploded[2];
    $services["$service/$proto"] = $port;
  }
  asort($services);
  #
  # Add the ICMP types
  #
  $icmpp = popen("/sbin/ipchains -h icmp", "r");
  # Discard first 3 lines of header
  $buffer = fgets($icmpp, 255);
  $buffer = fgets($icmpp, 255);
  $buffer = fgets($icmpp, 255);
  # Slurp the rest in
  while (!feof($icmpp)) {
    $buffer = trim(fgets($icmpp, 255));
    $buffer = ereg_replace(" .*$","",$buffer);
    if (empty($buffer)) continue;
    $services["$buffer/icmp"] = "ICMP";
  }
  $term = pclose($icmpp);

  return $services;
}

function read_objects() {
  global $CONF;

  $netobjectr = file("$CONF/netobjects");
  while ( list($key,$val ) = each($netobjectr) ) {
    #
    # Skip blank lines and comments
    #
    if ( strlen($val) < 5 ) continue;
    if ( substr($val, 0, 1) == "#" ) continue;
    $exploded = explode (" ", $val);
    $netobjects[$exploded[0]] = "$exploded[1] $exploded[2] " . chop($exploded[3]);
  }
  return $netobjects;
}

function write_objects($netobjects) {
  global $CONF;

  $objfile = fopen ("$CONF/netobjects","w+");
  reset($netobjects);
  while ( list($key,$val) = each($netobjects) ) {
    fwrite ($objfile, "$key $val\n");
  }
  fclose($objfile);
}

function read_rulesets() {
  global $CONF;

  $ruler = file("$CONF/rulesets");
  $rulekey = 100;
  while ( list( $key, $val ) = each($ruler) ) {
    #
    # Skip blank lines and comments
    #
    if ( strlen($val) < 5 ) continue;
    if ( substr($val, 0, 1) == "#" ) continue;
    $rules[$rulekey] = chop($val);
    $rulekey += 100;
  }
  return $rules;
}

function write_rulesets($rules) {
  global $CONF;

  $rulefile = fopen ("$CONF/rulesets","w+");
  reset($rules);
  while ( list($key,$val) = each($rules) ) {
    fwrite ($rulefile, "$val\n");
  }
  fclose ($rulefile);
}

function read_portfwds() {
  global $CONF;

  $ruler = file("$CONF/portfwds");
  $rulekey = 100;
  while ( list($key,$val ) = each($ruler) ) {
    #
    # Skip blank lines and comments
    #
    if ( strlen($val) < 5 ) continue;
    if ( substr($val, 0, 1) == "#" ) continue;
    $rules[$rulekey] = chop($val);
    $rulekey += 100;
  }
  return $rules;
}

function write_portfwds($portfwds) {
  global $CONF;

  $rulefile = fopen ("$CONF/portfwds","w+");
  reset($portfwds);
  while ( list($key,$val) = each($portfwds) ) {
    fwrite ($rulefile, "$val\n");
  }
  fclose ($rulefile);
}

function read_redirectors() {
  global $CONF;

  $ruler = file("$CONF/redirectors");
  $rulekey = 100;
  while ( list($key,$val ) = each($ruler) ) {
    #
    # Skip blank lines and comments
    #
    if ( strlen($val) < 5 ) continue;
    if ( substr($val, 0, 1) == "#" ) continue;
    $rules[$rulekey] = chop($val);
    $rulekey += 100;
  }
  return $rules;
}

function write_redirectors($redirectors) {
  global $CONF;

  $rulefile = fopen ("$CONF/redirectors","w+");
  reset($redirectors);
  while ( list($key,$val) = each($redirectors) ) {
    fwrite ($rulefile, "$val\n");
  }
  fclose ($rulefile);
}

?>
