<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 3.0//EN" "html.dtd">
<HTML>

<HEAD>
<TITLE>PHP Firewall Generator -- Start Here</TITLE>
<?php

#############################################################################
#
# $Id: index.php3,v 1.37 2000/03/26 22:11:20 delson Exp $
#
# PHP Firewall Generator by Del <del@babel.com.au>.  Original coding ideas
# from IPCHAINS-FIREWALL V1.6.2m by Ian Hall-Beyer
# and various others.
#
# (C) Del under the GPL.
#
#############################################################################

#
# Define some constants.
#

require ('files.inc');
require ('utility.inc');
require ('config.inc');
require ('javascript.inc');

gen_script();

?>

</HEAD>

<BODY BGCOLOR="#FFFFFF">

<TABLE WIDTH=100% BGCOLOR=#339933>
<TR>
  <TD ALIGN=LEFT VALIGN=TOP><FONT SIZE=+2 COLOR=WHITE>PHP Firewall Generator</FONT></TD>
</TR>
</TABLE>

<TABLE BORDER=0 CELLSPACING=2 CELLPADDING=4>

<TR><TD>&nbsp;</TD><TD><HR></TD></TR>

<TR><TD ALIGN=LEFT VALIGN=TOP><B>Introduction</B></TD>
<TD>

<A HREF="http://www.php.net/"><IMG SRC="phplogo1.gif" ALT="Powered by PHP" ALIGN=RIGHT BORDER=0></A>
This a PHP based firewall script
generator for ipchains based firewalls on Linux.
<P>
(c)
<A HREF="mailto:del@babel.com.au">Del</A>
1999 under the
<A HREF="http://www.gnu.org/copyleft/gpl.html">GPL</A>
<P>

Here are some very basic instructions:
<P>

<UL>
<LI>Make sure that your /etc/services file and /etc/protocols file
are correct.  You can't define any rules in your firewall for services
or protocols that don't exist in these files.
<LI>Make sure the interface list is correct.  This is for reference
purposes only and isn't actually used anywhere in the program, but
it does give you a sanity check to make sure that everything is defined
the way it should be.
<LI>Enter all of your network objects.
<LI>Enter your firewall rules, including port forwarding rules (used to
hide a server behind the firewall) and redirector rules (used for transparent
proxying of services to a proxy server on the firewall).
<LI>Once your firewall rules are entered, check the script at the bottom
of the page.  You can cut and paste this into a text editor and use it
as your firewall script.  You can also have it e-mailed to you.  The
script is also stored in /var/lib/phpfwgen/firewall if you want to
install it into your system startup folders.
</UL>

<?php
#
# Do some checks for installed software.
#
if (! file_exists("/sbin/ipchains") ) {
print "<FONT COLOR=\"#FF0000\">";
print "Warning!  /sbin/ipchains is not installed on this system.  The ";
  print "firewall script will not work without it.  You should install the ";
  print "ipchains package from your Linux distribution CD.";
  print "</FONT><P>\n";
}

if (! file_exists("/usr/sbin/ipmasqadm") ) {
  print "<FONT COLOR=\"#FF0000\">";
  print "Warning!  /usr/sbin/ipmasqadm is not installed on this system. ";
  print "Port forwarding will not work without it.  You should install the ";
  print "ipmasqadm RPM from the RedHat/contrib FTP site.";
  print "</FONT><P>\n";
}
?>

<HR></TD></TR>

<?php
#############################################################################
#
# Interfaces.
#
#############################################################################
?>

<TR><TD ALIGN=LEFT VALIGN=TOP>
<A HREF="javascript:openInterfaces();"><B>Interfaces</B></A>
</TD>

<TD>
The interface list is for reference purposes only.
<P>

<HR></TD></TR>

<?php
#############################################################################
#
# Protocols.
#
#############################################################################
?>

<TR><TD ALIGN=left VALIGN=top>
<A HREF="javascript:openProtocols();"><B>Protocols</B></A>
</TD>

<TD>
The protocols table is for reference only.
<P>

<HR></TD></TR>

<?php
#############################################################################
#
# Services.
#
#############################################################################
?>

<TR><TD ALIGN=left VALIGN=top>
<A HREF="javascript:openServices();"><B>Services</B></A>
</TD>

<TD>
The services table is for reference only.
<P>

<HR></TD></TR>

<?php
#############################################################################
#
# Open ports.
#
#############################################################################
?>

<TR><TD ALIGN=left VALIGN=top>
<A HREF="javascript:openPorts();"><B>Open Ports</B></A>
</TD>

<TD>
The open ports table is for reference only.
<P>

<HR></TD></TR>
 
<?php
#############################################################################
#
# Network Objects.
#
#############################################################################
?>

<TR><TD ALIGN=left VALIGN=top>
<A HREF="javascript:openObjects();"><B>Network Objects</B></A>
</TD>

<TD>
Enter all of your network objects here.
<P>

<HR></TD></TR>

<?php
#############################################################################
#
# Firewall Rules.
#
#############################################################################
?>

<TR><TD ALIGN=left VALIGN=top>
<A HREF="javascript:openRules();"><B>Firewall Rules</B></A>
</TD>

<TD>
Enter your firewall rules here.
<P>

<HR></TD></TR>

<?php
#############################################################################
#
# Port Forward Rules.
#
#############################################################################
?>

<TR><TD ALIGN=left VALIGN=top>
<A HREF="javascript:openPortfwd();"><B>Port Forwarding Rules</B></A>
</TD>

<TD>
Enter your port forwarding rules here.  You only need these if you are
going to forward TCP or UDP ports from the firewall to a server that
is masqueraded behind the firewall.
<P>

<HR></TD></TR>

<?php
#############################################################################
#
# Redirector Rules.
#
#############################################################################
?>

<TR><TD ALIGN=left VALIGN=top>
<A HREF="javascript:openRedirect();"><B>Redirector Rules</B></A>
</TD>

<TD>
Enter your redirector rules here.  You only need these if you are going
to offer transparent proxying services on your firewall.
<P>

<HR></TD></TR>

<?php
#############################################################################
#
# Firewall Script.
#
#############################################################################
?>

<TR><TD ALIGN=left VALIGN=top>
<A HREF="javascript:openScript();"><B>Current Script</B></A>
</TD>

<TD>
Click here to see the current firewall script.
<P>

<HR></TD></TR>

<?php
#############################################################################
#
# End notes.
#
#############################################################################
?>

<TR><TD ALIGN=LEFT VALIGN=TOP>
<B>TODO:</B></A>
</TD>

<TD>
To Do List:
<P>

<UL>
<LI>Install the script automatically.
<LI>Start and stop the firewall.
<LI>Automatic VPN configuration.
<LI>Negation rules, when an object is prepended by "!" in the files.
<LI>Support for
<A HREF="http://netfilter.kernelnotes.org/">NAT/iptables/ipfilter</A>
<LI>Currently a rule that allows all outgoing traffic on all ports
also allows all incoming non-SYN traffic on all ports (for TCP responses).
It'd be better to allow only incoming traffic on the ports that were
actually in use for outgoing socket connections, but this isn't possible
in ipchains.  Currently this is attempted for UDP by allowing incoming
packets packets on
the high ports (1024:65535) but this is unsuitable since many programs
now bind to UDP ports in this range for incoming connections,
and also these ports are often used for hacks (eg: NetBus, BackOrifice).
Find a good solution to this problem!
<LI>A partial solution is to DENY incoming connections on known bad
UDP ports (eg: 12345 and 23456 for NetBus).  These
must be in place before other (legal)
outgoing UDP connections (eg: for DNS).
<LI>A better solution might be to use the stateful packet filtering
code at ftp://ftp.interlinx.bc.ca/pub/spf/
<LI>Find a more comprehensive /etc/services file somewhere.
</UL>
<P>

<HR></TD></TR>

<TR><TD ALIGN=LEFT VALIGN=TOP>
<B>Credits</B></A>
</TD>

<TD>
I got some ideas from various places, including Godot's Muse and
IPCHAINS-FIREWALL V1.6.2m by Ian Hall-Beyer.  Ed McLain took my
code and used it in PHPChains, so I took parts of his ideas back
and incorporated them.
<P>

<HR></TD></TR>

</TABLE>

</BODY>
</HTML>
