<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 3.0//EN" "html.dtd">
<HTML>

<HEAD>
<TITLE>PHP Firewall Generator -- Create / Edit a Redirector Rule</TITLE>
<?php

#############################################################################
#
# $Id: newredir.php3,v 1.2 2000/03/25 02:51:36 del Exp $
#
# Script to create or edit redirector rules.
#
# (C) Del under the GPL.
#
#############################################################################

require ('config.inc');
require ('files.inc');

$protocols = read_protocols();
$services = read_services();
$netobjects = read_objects();
$redirectors = read_redirectors();

require ('utility.inc');
require ('submit.inc');
require ('javascript.inc');

?>
</HEAD>

<BODY BGCOLOR="#FFFFFF">

<SCRIPT LANGUAGE="JavaScript">
<!-- hide from JavaScript-challenged browsers
  reloadParent();
// done hiding -->
</SCRIPT>

<TABLE WIDTH="99%" BORDER=0 BGCOLOR="#EEEEEE" CELLSPACING=2 CELLPADDING=4>
  <TR ALIGN=LEFT VALIGN=TOP>
    <TD BGCOLOR=#339933><FONT SIZE=+1 COLOR=WHITE><B>Create or Edit a Redirector Rule</B></FONT></TD>
  </TR>
  <TR ALIGN=LEFT VALIGN=TOP>
    <TD>Enter your redirector rules here.  You need to enter the
    following for each rule:

    <UL>
    <LI><B>Rule Number</B>: This defines where the rule is entered into
    the list.  For example, to enter a new rule between 100 and 200,
    number it "150".  The rules will be re-numbered on each iteration
    of the firewall, so you can continue entering rules between each
    new pair of rules.  If you leave this blank then the rule will go
    at the end of the rule set.
    <LI><B>Source</B>: Select a source network object (where the packet
    is coming from).
    <LI><B>Destination</B>: Select a destination network object (where the
    packet is going to).
    <LI><B>Protocol</B>: Select a network protocol, udp or tcp.
    <LI><B>From Port</B>: What port the redirection is starting from
    (what port the packet was originally sent to).  For example, to redirect
    traffic for external web servers, enter the port name <B>www</B>.
    <LI><B>To Port</B>: Select the port that
    the packet is to be redirected to.  For example, if you have a squid
    proxy server on the firewall, listening on port <B>squidproxy</B>, then
    enter the port name <B>squidproxy</B>.
    </UL>

    Note that the <B>From Port</B> and <B>To Port</B> must both use
    the same protocol.  You cannot redirect a TCP connection to a UDP port.
    <P></TD>

  </TR>
</TABLE>

<TABLE WIDTH="99%" BORDER=0 BGCOLOR="#EEEEEE" CELLSPACING=2 CELLPADDING=4>

<?php
#
# A form to add or edit a rule.
#

  if ($redirectorkey == 0) {
    $source = "ALL";
    $dest = "ALL";
    $proto = "tcp";
    $sport = "ALL";
    $dport = "ALL";
    $redirectorkey = "";
  } else {
    $rule = $redirectors[$redirectorkey];
    list ($source, $dest, $proto, $sport, $dport)
      = preg_split ("/[\s]+/", $rule);
  }
?>

<FORM NAME="addredir" METHOD="POST" ACTION="newredir.php3">
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><B>Rule Number</B></TD>
    <TD><INPUT TYPE="TEXT" NAME="newredirectorkey" SIZE=5 MAXLENGTH=5 VALUE="<?php print $redirectorkey; ?>"></TD>
  </TR>
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><B>Source</B></TD>
    <TD><SELECT NAME="source">
      <?php
      reset($netobjects);
      while ( list($key,$val) = each($netobjects) ) {
        if ($key == $source) {
          print "<OPTION SELECTED>$key\n";
        } else {
          print "<OPTION>$key\n";
        }
      }
      ?>
        </SELECT>
    </TD>
  </TR>
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><B>Destination</B></TD>
    <TD><SELECT NAME="dest">
      <?php
      reset($netobjects);
      while ( list($key,$val) = each($netobjects) ) {
        if ($key == $dest) {
          print "<OPTION SELECTED>$key\n";
        } else {
          print "<OPTION>$key\n";
        }
      }
      ?>
        </SELECT>
    </TD>
  </TR>
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><B>Protocol</B></TD>
    <TD><SELECT NAME="newproto">
      <?php if ($proto == "tcp") { ?>
        <OPTION SELECTED>tcp
        <OPTION>udp
      <?php } else { ?>
        <OPTION SELECTED>udp
        <OPTION>tcp
      <?php } ?>
        </SELECT>
    </TD>
  </TR>
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><B>From Port</B></TD>
    <TD><SELECT NAME="newsrcport">
      <?php
        reset($services);
        while ( list($key,$val) = each($services) ) {
          if (ereg ("/udp$|/tcp$", $key)) {
            if ($key == "$sport/$proto") {
              print "<OPTION SELECTED>$key\n";
            } else {
              print "<OPTION>$key\n";
            }
          }
        }
      ?>
        </SELECT>
    </TD>
  </TR>
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><B>To Port</B></TD>
    <TD><SELECT NAME="newdstport">
      <?php
        reset($services);
        while ( list($key,$val) = each($services) ) {
          if (ereg ("/udp$|/tcp$", $key)) {
            if ($key == "$dport/$proto") {
              print "<OPTION SELECTED>$key\n";
            } else {
              print "<OPTION>$key\n";
            }
          }
        }
      ?>
        </SELECT>
    </TD>
  </TR>
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><B>Submit</B></TD>
    <TD><INPUT TYPE=IMAGE SRC=mini-tick.gif NAME=createredirector BORDER=0></TD>
  </TR>
</FORM>

</TABLE>
</BODY>
</HTML>
