<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 3.0//EN" "html.dtd">
<HTML>

<HEAD>
<TITLE>PHP Firewall Generator -- Create / Edit a Firewall Rule</TITLE>
<?php

#############################################################################
#
# $Id: newrule.php3,v 1.3 2000/03/25 11:01:21 delson Exp $
#
# Script to create or edit firewall rules.
#
# (C) Del under the GPL.
#
#############################################################################

require ('config.inc');
require ('files.inc');

$protocols = read_protocols();
$services = read_services();
$netobjects = read_objects();
$rules = read_rulesets();

require ('utility.inc');
require ('submit.inc');
require ('javascript.inc');

?>
</HEAD>

<BODY BGCOLOR="#FFFFFF">

<SCRIPT LANGUAGE="JavaScript">
<!-- hide from JavaScript-challenged browsers
  reloadParent();
// done hiding -->
</SCRIPT>

<TABLE WIDTH="99%" BORDER=0 BGCOLOR="#EEEEEE" CELLSPACING=2 CELLPADDING=4>
  <TR ALIGN=LEFT VALIGN=TOP>
    <TD BGCOLOR=#339933><FONT SIZE=+1 COLOR=WHITE><B>Create or Edit a Firewall Rule</B></FONT></TD>
  </TR>
  <TR ALIGN=LEFT VALIGN=TOP>
    <TD>Enter your firewall rules here.  You need to enter the following
    for each rule:
    <UL>
    <LI><B>Rule Number</B>: This defines where the rule is entered into
    the list.  For example, to enter a new rule between 100 and 200,
    number it "150".  The rules will be re-numbered on each iteration
    of the firewall, so you can continue entering rules between each
    new pair of rules.  If you leave this blank then the rule will go
    at the end of the rule set.
    <LI><B>Source</B>: Select a source network object (where the packet
    is coming from).
    <LI><B>Destination</B>: Select a destination network object (where the
    packet is going to).
    <LI><B>Protocol</B>: Select a network protocol, or ALL for all protocols.
    <LI><B>Service</B>: Select a network port, or ALL for all ports.  Note that
    most ports will also define a protocol, eg: telnet/tcp is for the tcp
    protocol.
    <LI><B>Action</B>: This will be ACCEPT or DENY.
    <LI><B>Log</B>: YES to log the packet, NO to not bother logging it.
    <LI><B>Direction</B>: IN for input packets, FWD for forwarded packets,
    OUT for output packets (mostly used for VPN servers), or IN/FWD for
    packets that can be either input or forwarded.
    </UL>
    <P></TD>

  </TR>
</TABLE>

<TABLE WIDTH="99%" BORDER=0 BGCOLOR="#EEEEEE" CELLSPACING=2 CELLPADDING=4>

<?php
#
# A form to add or edit a rule.
#

  if ($rulekey == 0) {
    $source = "ALL";
    $dest = "ALL";
    $proto = "ALL";
    $port = "ALL";
    $action = "DENY";
    $log = "YES";
    $direction = "IN/FWD";
    $rulekey = "";
  } else {
    $rule = $rules[$rulekey];
    list ($source, $dest, $proto, $port, $action, $log, $direction)
      = preg_split ("/[\s]+/", $rule);
    # Do this for compatibility with previous versions of phpfwgen which
    # didn't use the direction flag ...
    if (empty($direction)) {
      $direction = "IN/FWD";
    }
  }
?>

<FORM NAME="addrule" METHOD="POST" ACTION="newrule.php3">
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><B>Rule Number</B></TD>
    <TD><INPUT TYPE="TEXT" NAME="newrulekey" SIZE=5 MAXLENGTH=5 VALUE="<?php print $rulekey; ?>"></TD>
  </TR>
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><B>Source</B></TD>
    <TD><SELECT NAME="source">
<?php
reset($netobjects);
while ( list($key,$val) = each($netobjects) ) {
  if ($key == $source) {
    print "<OPTION SELECTED>$key\n";
  } else {
    print "<OPTION>$key\n";
  }
}
?>
        </SELECT>
    </TD>
  </TR>
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><B>Destination</B></TD>
    <TD><SELECT NAME="dest">
      <?php
      reset($netobjects);
      while ( list($key,$val) = each($netobjects) ) {
        if ($key == $dest) {
          print "<OPTION SELECTED>$key\n";
        } else {
          print "<OPTION>$key\n";
        }
      }
      ?>
        </SELECT>
    </TD>
  </TR>
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><B>Protocol</B></TD>
    <TD><SELECT NAME="newproto">
        <OPTION SELECTED><?php print "$proto\n"; ?>
        <OPTION>ALL
      <?php
      reset($protocols);
      while ( list($key,$val) = each($protocols) ) {
        print "<OPTION>$key\n";
      }
      ?>
        </SELECT>
    </TD>
  </TR>
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><B>Service</B></TD>
    <TD><SELECT NAME="newport">
      <?php if ($port == "ALL") { ?>
        <OPTION SELECTED>ALL
      <?php } else { ?>
        <OPTION SELECTED><?php print "$port/$proto\n"; ?>
        <OPTION>ALL
      <?php } ?>
      <?php
      reset($services);
      while ( list($key,$val) = each($services) ) {
        print "<OPTION>$key\n";
      }
      ?>
        </SELECT>
    </TD>
  </TR>
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><B>Action</B></TD>
    <TD><SELECT NAME="action">
      <?php if ($action == "ACCEPT") { ?>
        <OPTION SELECTED>ACCEPT
        <OPTION>DENY
      <?php } else { ?>
        <OPTION SELECTED>DENY
        <OPTION>ACCEPT
      <?php } ?>
        </SELECT>
    </TD>
  </TR>
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><B>Log</B></TD>
    <TD><SELECT NAME="log">
      <?php if ($log == "YES") { ?>
        <OPTION SELECTED>YES
        <OPTION>NO
      <?php } else { ?>
        <OPTION SELECTED>NO
        <OPTION>YES
      <?php } ?>
        </SELECT>
    </TD>
  </TR>
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><B>Direction</B></TD>
    <TD><SELECT NAME="direction">
      <?php if ($direction == "IN/FWD") { ?>
        <OPTION SELECTED>IN/FWD
      <?php } else { ?>
        <OPTION>IN/FWD
      <?php } ?>
      <?php if ($direction == "IN") { ?>
        <OPTION SELECTED>IN
      <?php } else { ?>
        <OPTION>IN
      <?php } ?>
      <?php if ($direction == "FWD") { ?>
        <OPTION SELECTED>FWD
      <?php } else { ?>
        <OPTION>FWD
      <?php } ?>
      <?php if ($direction == "OUT") { ?>
        <OPTION SELECTED>OUT
      <?php } else { ?>
        <OPTION>OUT
      <?php } ?>
        </SELECT>
    </TD>
  </TR>
  <TR ALIGN=LEFT VALIGN=MIDDLE>
    <TD><B>Submit</B></TD>
    <TD><INPUT TYPE=IMAGE SRC=mini-tick.gif NAME=createrule BORDER=0></TD>
  </TR>
</FORM>

</TABLE>
</BODY>
</HTML>
