<?php

#############################################################################
#
# Form/Submit handler.
#
#############################################################################

#
# Check if there was a submission.
#
while ( is_array($HTTP_POST_VARS)
     && list($key, $val) = each($HTTP_POST_VARS)) {
  switch ($key) {

    #
    # Create a new network object.
    #
    case "createobject_x":
      if (empty($newobjectname) || empty($newnetaddr) || empty($newnetmask)) {
        break;
      }
      $netobjects[$newobjectname] = "$newnetaddr $newnetmask $newmasq";
      write_objects($netobjects);
      gen_script();
    break;

    #
    # Delete a network object.
    #
    case "delobject_x":
      unset($netobjects[$objectname]);
      write_objects($netobjects);
      gen_script();
    break;

    #
    # Create a firewall rule.
    #
    case "createrule_x":
      if (empty($newrulekey)) {
        $newrulekey = 99999;
      }
      if ($newport != "ALL") {
        $exploded = preg_split ("/[\s\/]+/", $newport);
        if ($newproto == "ALL") $newproto = $exploded[1];
        if ($newproto != $exploded[1]) break;
        $newport = $exploded[0];
      }
      $rules[$newrulekey] = "$source $dest $newproto $newport $action $log $direction";
      ksort($rules);
      write_rulesets($rules);
      gen_script();
      $rules = read_rulesets();
    break;

    #
    # Delete a firewall rule.
    #
    case "delrule_x":
      unset($rules[$rulekey]);
      write_rulesets($rules);
      gen_script();
      $rules = read_rulesets();
    break;

    #
    # Create a port forwarding rule.
    #
    case "createportfwd_x":
      if (empty($newportfwdkey)) {
        $newportfwdkey = 999999;
      }
      $exploded = preg_split ("/[\s\/]+/", $newsrcport);
      $newproto = $exploded[1];
      $srcport = $exploded[0];
      $exploded = preg_split ("/[\s\/]+/", $newdstport);
      $dstport = $exploded[0];
      $portfwds[$newportfwdkey] = "$newproto $source $srcport $dest $dstport";
      ksort($portfwds);
      write_portfwds($portfwds);
      gen_script();
      $portfwds = read_portfwds();
    break;

    #
    # Delete a port forwarding rule.
    #
    case "delportfwd_x":
      unset($portfwds[$portfwdkey]);
      write_portfwds($portfwds);
      gen_script();
      $portfwds = read_portfwds();
    break;

    #
    # Create a redirector rule.
    #
    case "createredirector_x":
      if (empty($newredirectorkey)) {
        $newredirectorkey = 99999;
      }
      $exploded = preg_split ("/[\s\/]+/", $newsrcport);
      $newproto = $exploded[1];
      $srcport = $exploded[0];
      $exploded = preg_split ("/[\s\/]+/", $newdstport);
      $dstport = $exploded[0];
      $redirectors[$newredirectorkey] = "$source $dest $newproto $srcport $dstport";
      ksort($redirectors);
      write_redirectors($redirectors);
      gen_script();
      $redirectors = read_redirectors();
    break;

    #
    # Delete a redirector rule.
    #
    case "delredirector_x":
      unset($redirectors[$redirectorkey]);
      write_redirectors($redirectors);
      gen_script();
      $redirectors = read_redirectors();
    break;

    #
    # Send the script via e-mail.
    #
    case "sendemail":
      $message = implode (file("$CONF/firewall"), "");
      mail($emailaddress, "Firewall script", $message);
    break;

    default:
      # print "$key ";
    break;
  } # end switch
} # end while

?>
